{ **********************************************************************
  ***     HORIZONTAL DIAL     T E X T U A L    D E P I C T I O N     ***
  ***     VERTICAL                                                   ***
  ***     HORIZONTAL DIAL     G R A P H I C A L    D E P I C T I O N ***
  ***     VERTICAL                                                   ***
  ***     For the vertical decliner, see a different project/program ***
  **********************************************************************

  January 13, 2009
  www.illustratingshadows.com
  Simon Wheaton-Smith

  open source, see policy on the above web site

  Horizontal and vertical sundial program
  PROJECT:   HandVdialGrProject.lpi
  MAIN CODE: hdialv1.pas
}

unit hdialv1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, math, ComCtrls, Grids;
  { for tan to work as well as arcxxx then "math" must be in the uses
  }

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure StaticText2Click(Sender: TObject);
    procedure StaticText6Click(Sender: TObject);
    procedure StaticText7Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }

    longitude     : single ;
    legalmeridian : single ;
    difflong      : single ;
    difflongstring: String ;
    tempint       : integer;
   end;

var
  Form1: TForm1; 

implementation

{ TForm1 }

{   ***   The form is what dominates everything below it.
    ***   That form has buttons and things, and they have events.
    ***   When a button is clicked, its even is called.
    ***   The form's BUTTON1 when clicked comes here.
    ***   This code is the HORIZONTAL dial.
    ***
}

{ ********************************************************************** }
{ ***     HORIZONTAL DIAL      T E X T U A L    D E P I C T I O N    *** }
{ ********************************************************************** }

procedure TForm1.Button1Click(Sender: TObject);
var { must declare FOR variables in the section in which they are used }
    irow          : integer;
    icol          : integer;
    sinOrCoslat   : single ;
    tanlha        : single ;
    hlat          : single ;
    hla           : single ;
    ii            : single ;
    jj            : single ;
    degtorad      : single ;
    radtodeg      : single ;
begin

  { for no good reason, change another button's caption }
  Button2.Caption := 'CLOSE';

  { get the numeric values of the longitude and legal meridian }
  { single(Edit2.Text)  or  StrToFloat(Edit2.Text) will do a conversion   }
  difflong    := StrToFloat(Edit2.Text) - StrToFloat(Edit3.Text) ;

  { get the difference as text also }
  StaticText4.Caption := 'standby';
  difflongstring      := FloatToStr (difflong) ;
  { and drop the low order digits which are useless }
  StaticText4.Caption := LeftStr (difflongstring,3);

  { dial type is... }
  StaticText7.Caption := 'H-DIAL';

  { StringGrid1 is a TStringGrid array with 3 columns and 8 rows }

  degtorad := (2 * 3.14162) / 360 ;
  radtodeg := 360 / (2 * 3.14162) ;

  for irow := 1 to 7 do
  begin
          for icol := 1 to 2 do
          begin
                {  StringGrid1.row := irow;
                   StringGrid1.col := icol;                     not using this}
                {  StringGrid1.Cells[icol,irow] := something    am using this }
                { get sin(lat) }
                sinOrCoslat := sin( degtorad * StrToFloat(Edit1.Text) ) ;

                { get the hour angle of the sun }
                ii := irow - 1 ;
                jj := difflong + (15 * ii) ;
                { however col 2 (actually col 3) is afternoon }
                if icol = 2 then
                   jj := difflong - (15 * ii) ;

                { get the resulting hour line angle ~ atan(sin(lat)*tan(hr*15) }
                { no tan support unless "math" is in the "uses" at the top, so
                  I used sin/cos. However the vertical decliner sis use math so
                  it can use tan as well as arcxxx functions other than arctan }
                tanlha := sin ( degtorad * jj) / cos ( degtorad * jj)  ;
                hlat:= sinOrCoslat * tanlha ;

                { get the hour line angle back to degrees }
                hla := radtodeg * arctan(hlat)  ;

                {
                *     T E S T    D A T A     L A T I T U D E    3 0
                *                            DIAL LONG 3 DEGREES WEST
                *     LAT          32
                *     LONG.DIF      3
                *     IS MINS      12
                *     HR FR NOON   AM         PM
                *     0             2          2
                *     1            10          6
                *     2            19         15
                *     3            31         26
                *     4            46         39
                *     5            68         59
                *     6            84         84
                }

                { make numbers be positive }
                if hla < 0 then hla := -hla;

                { As signs are removed, noon is west of N:S if dial is west
                  of meridian, east if east. }
                StringGrid1.Cells[icol,irow] := LeftStr (FloatToStr(hla),5) ;
          end;
  end ;

  { if east or west of noon, drop one of the noon figures }
  if difflong > 0 then StringGrid1.Cells[2,1] := ' ';
  if difflong < 0 then StringGrid1.Cells[1,1] := ' ';

end;


{   ***   The form is what dominates everything below it.
    ***   That form has buttons and things, and they have events.
    ***   When a button is clicked, its even is called.
    ***   The form's BUTTON2 when clicked comes here.
    ***   This code is the VERTICAL dial.
    ***
}
procedure TForm1.Button2Click(Sender: TObject);
begin
  close ;
end;



{ ********************************************************************** }
{ ***     VERTICAL DIAL        T E X T U A L    D E P I C T I O N    *** }
{ ********************************************************************** }

procedure TForm1.Button3Click(Sender: TObject);
var { must declare FOR variables in the section in which they are used }
    irow          : integer;
    icol          : integer;
    sinOrCoslat   : single ;
    tanlha        : single ;
    hlat          : single ;
    hla           : single ;
    ii            : single ;
    jj            : single ;
    degtorad      : single ;
    radtodeg      : single ;
begin

  { for no good reason, change another button's caption }
  Button2.Caption := 'CLOSE';

  { get the numeric values of the longitude and legal meridian }
  { single(Edit2.Text)  or  StrToFloat(Edit2.Text) will do a conversion   }
  difflong    := StrToFloat(Edit2.Text) - StrToFloat(Edit3.Text) ;

  { get the difference as text also }
  StaticText4.Caption := 'standby';
  difflongstring      := FloatToStr (difflong) ;
  { and drop the low order digits which are useless }
  StaticText4.Caption := LeftStr (difflongstring,3);

  { dial type is... }
  StaticText7.Caption := 'V-DIAL';

  { StringGrid1 is a TStringGrid array with 3 columns and 8 rows }

  degtorad := (2 * 3.14162) / 360 ;
  radtodeg := 360 / (2 * 3.14162) ;

  for irow := 1 to 7 do
  begin
          for icol := 1 to 2 do
          begin
                {  StringGrid1.row := irow;
                   StringGrid1.col := icol;                     not using this}
                {  StringGrid1.Cells[icol,irow] := something    am using this }
                { get sin(lat) }
                sinOrCoslat := cos( degtorad * StrToFloat(Edit1.Text) ) ;

                { get the hour angle of the sun }
                ii := irow - 1 ;
                jj := difflong + (15 * ii) ;
                { however col 2 (actually col 3) is afternoon }
                if icol = 2 then
                   jj := difflong - (15 * ii) ;

                { get the resulting hour line angle ~ atan(sin(lat)*tan(hr*15) }
                { no tan support so I used sin/cos }
                tanlha := sin ( degtorad * jj) / cos ( degtorad * jj)  ;
                hlat:= sinOrCoslat * tanlha ;

                { get the hour line angle back to degrees }
                hla := radtodeg * arctan(hlat)  ;

                { make numbers be positive }
                if hla < 0 then hla := -hla;

                { As signs are removed, noon is west of N:S if dial is west
                  of meridian, east if east. }
                StringGrid1.Cells[icol,irow] := LeftStr (FloatToStr(hla),5) ;
          end;
  end ;

  { if east or west of noon, drop one of the noon figures }
  if difflong > 0 then StringGrid1.Cells[2,1] := ' ';
  if difflong < 0 then StringGrid1.Cells[1,1] := ' ';

end;



{ ********************************************************************** }
{ ***     S T A RT     O F    H O R I Z O N T A L     G R A P H      *** }
{ ********************************************************************** }

procedure TForm1.Button4Click(Sender: TObject);

{
     KEY POINTS TO REMEMBER:
     0,0   top left
     y increases positively down

     DOCUMENTATION:
     http://delphi.about.com/library/bluc/text/uc052102a.htm     [ is page 1 ]
     http://delphi.about.com/library/bluc/text/uc052102b.htm     [ is page 2 ]
}

var { must declare FOR variables in the section in which they are used }
    irow          : integer;
    icol          : integer;
    sinlat        : single ;
    hla           : single ;
    ii, jj        : single ;
    degtorad      : single ;
    radtodeg      : single ;
    lat           : single ;

    { bias for x and y, and scaling factor }
    xbias, ybias  :SmallInt;
    xyscl, xysiz  :SmallInt;
    halfxysiz     :SmallInt;

    x,y           :single  ;
    xl,yl         :longint ;
    hour          :integer ;
    s             :string  ;

begin
  { starting point, all x and y values have these added in before a draw }
  xbias     :=  15;
  ybias     := 113;
  xyscl     :=   2;
  xysiz     := 100;
  halfxysiz :=  50;
  { NOTE that OUR drawing box of 0,0 to 100,100 [i.e. xysiz] scaled by xyscl
    and moved by a bias of xbias, ybias }

  { build radians and degrees converters }
  degtorad  := (2 * 3.14162) / 360 ;
  radtodeg  := 360 / (2 * 3.14162) ;

  { remove wording to redraw screen }
  { see FormPaint }
  { http://delphi.about.com/library/bluc/text/uc052102d.htm }
  { clear the graph area see: http://delphi.about.com/library/bluc/text/uc052102c.htm}
  Canvas.Rectangle( Bounds(xbias-10, ybias-15, 25+xyscl*xysiz, 35+xyscl*xysiz));

  { say what is depicted }
  Canvas.TextOut  ( xbias+xyscl*0,      ybias-xyscl*7  ,'h dial');

  { move to a starting point if 0,0 (top left) scales and biased of course }
  Canvas.MoveTo   ( xbias+xyscl*0,        ybias+xyscl*0     );
  {                            **                  **
                         user's x            user's y
  }

  { draw a box }
  Canvas.Pen.Color :=  100;   { dark brown }
  Canvas.Pen.Width :=    1;
  Canvas.LineTo    ( xbias+xyscl*xysiz,    ybias+xyscl*0     );
  Canvas.LineTo    ( xbias+xyscl*xysiz,    ybias+xyscl*xysiz );
  Canvas.LineTo    ( xbias+xyscl*0,        ybias+xyscl*xysiz );
  Canvas.LineTo    ( xbias+xyscl*0,        ybias+xyscl*0     );

  { turn pen off and move to top center }
  Canvas.MoveTo    ( xbias+xyscl*halfxysiz,ybias+xysiz       );

  { get the numeric values of the longitude and legal meridian }
  { single(Edit2.Text)  or  StrToFloat(Edit2.Text) will do a conversion   }
  difflong         := StrToFloat(Edit2.Text) - StrToFloat(Edit3.Text) ;

  { get the difference as text also }
  difflongstring   := FloatToStr (difflong) ;

  { get latitude }
  lat :=  StrToFloat(Edit1.Text);

  { StringGrid1 is a TStringGrid array with 3 columns and 8 rows }
  degtorad := (2 * 3.14162) / 360 ;
  radtodeg := 360 / (2 * 3.14162) ;

  { get sin and cos(lat) and cos and sin(dec) }
  sinlat   := sin( degtorad * lat ) ;

  { if difflong = 0 then we get divide by 0 later to change to trivial number
    that gives a good noon hor lien angle }
  if difflong = 0 then  difflong := 0.001 ;

  {           1 <---- would be noon }
  for irow := 2 to 6 do
  begin
          for icol := 1 to 2 do
          begin
                { get the hour angle of the sun }
                ii := irow - 1 ;
                jj := difflong + (15 * ii) ;
                { however col 2 (actually col 3) is afternoon }
                if icol = 2 then jj := difflong - (15 * ii) ;

                { get the resulting hour line angle }
                { if you dont include "math" in the "uses" at the top, then
                  there is no tan support so you can use sin/cos }

                hla := radtodeg * arctan( sinlat * tan(degtorad*jj) );

                { make numbers be positive }
                if hla < 0 then hla := -hla;

                { As signs are removed, noon is west of N:S if dial is west
                  of meridian, east if east. }

                { *** draw line here
                      *** is icol = 1 then am so x values are left of center
                      *** is icol = 2 then pm so x values are right of center
                }
                { move pen to top and center }
                Canvas.Pen.Width :=    1;
                Canvas.Pen.Color :=  255;
                Canvas.Pen.Color :=  250;
                Canvas.MoveTo    ( xbias+xyscl*halfxysiz,ybias+xyscl*xysiz );
                { angles of less than atan(0.5) have y=100, and you derive x,
                  angles of more than atan(0.5) have x=-50, and you derive y,
                         and atan(0.5) is 26.56505
                  if am, or if noon and dial is west of legal meridian then
                         lines are left of center,
                  if pm, or if noon and dial is east of legal meridian then
                         lines are right of center
                  AM happens if icol = 1, and
                  PM happens if icol = 2
                }
                if hla < 26.56505 then
                begin
                    y  := 100;                               { x,y are floating point }
                    x  := int (y * (tan(degtorad*hla))) ;    { integer part, but still float }
                    { -----------------------------------------------------------------------}
                    {    x,y           :single  ;     ie floating point ------
                         xl,yl         :longint ;     ie integer        ------
                         the objectove it to convert a floating point to an integer }
                    { -----------------------------------------------------------------------}

                    s   := FloatToStrF (y,ffFixed,3,0);
                    yl  := StrToInt (s);

                    s   := FloatToStrF (x,ffFixed,3,0);
                    xl  := StrToInt (s);

                    { draw the line }
                    if icol = 1 then
                       begin
                          xl := halfxysiz - xl;
                       end ;
                    if icol = 2 then
                       begin
                          xl := halfxysiz + xl;
                       end ;
                    Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*xysiz-xyscl*yl );
                    { -----------------------------------------------------------------------}
                end;
                if hla > 26.56504 then
                begin
                    x  := 50;
                    y  := x/tan(degtorad*hla);
                    { ---------------------------------------------------------------------------}

                    s  := FloatToStrF (y,ffFixed,3,0);
                    yl  := StrToInt (s);

                    s  := FloatToStrF (x,ffFixed,3,0);
                    xl  := StrToInt (s);

                    { draw the line }
                    if icol = 1 then
                       begin
                          xl := halfxysiz - xl;
                       end ;
                    if icol = 2 then
                       begin
                          xl := halfxysiz + xl;
                       end ;
                    Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*xysiz-xyscl*yl );
                    { -----------------------------------------------------------------------}
                end;

                { display the hour }
                if icol = 1 then
                   hour := 13 - irow;
                if icol = 2 then
                   hour := 11 + irow;
                Canvas.TextOut  ( xbias+xyscl*xl,5+ybias+xyscl*xysiz-xyscl*yl, IntToStr(hour) );

                { having drawn the line, reset to top and center }
                Canvas.MoveTo   ( xbias+xyscl*halfxysiz,  ybias+xyscl*xysiz     );
          end;
  end ;

  { *** NOON *** }
  { get the hour angle of the sun for noon }
  jj := difflong ;

  { get the resulting hour line angle }
  hla := radtodeg * arctan( sinlat*tan(degtorad*jj) );

  { make numbers be positive }
  if hla < 0 then hla := -hla;

  { As signs are removed, noon is west of N:S if dial is west
    of meridian, east if east. }

  { move pen to top and center }
  Canvas.Pen.Width :=    1;
  Canvas.Pen.Color :=  255;
  Canvas.Pen.Color :=  250;
  Canvas.MoveTo    ( xbias+xyscl*halfxysiz,ybias+xyscl*xysiz      );

  y   := 100;                               { x,y are floating point }
  x   := int (y * (tan(degtorad*hla))) ;    { integer part, but still float }

  s   := FloatToStrF (y,ffFixed,3,0);
  yl  := StrToInt (s);

  s   := FloatToStrF (x,ffFixed,3,0);
  xl  := StrToInt (s);

  { draw the line }
  if difflong >=0 then
     begin
        xl := halfxysiz - xl;
     end ;
  if difflong <0 then
     begin
        xl := halfxysiz + xl;
     end ;
  Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*xysiz-xyscl*yl );
  Canvas.TextOut  ( xbias+xyscl*xl,  5+ybias+xyscl*xysiz-xyscl*yl, '12');

  { having drawn the line, reset to top and center }
  Canvas.MoveTo   ( xbias+xyscl*halfxysiz,  ybias+xysiz   );

end;




{ ********************************************************************** }
{ ***     S T A RT     O F    V E R T I C A L     G R A P H          *** }
{ ********************************************************************** }

procedure TForm1.Button5Click(Sender: TObject);

{
     KEY POINTS TO REMEMBER:
     0,0   top left
     y increases positively down

     DOCUMENTATION:
     http://delphi.about.com/library/bluc/text/uc052102a.htm     [ is page 1 ]
     http://delphi.about.com/library/bluc/text/uc052102b.htm     [ is page 2 ]
}

var { must declare FOR variables in the section in which they are used }
    irow          : integer;
    icol          : integer;
    coslat        : single ;
    hla           : single ;
    ii, jj        : single ;
    degtorad      : single ;
    radtodeg      : single ;
    lat           : single ;

    { bias for x and y, and scaling factor }
    xbias, ybias  :SmallInt;
    xyscl, xysiz  :SmallInt;
    halfxysiz     :SmallInt;

    x,y           :single  ;
    xl,yl         :longint ;
    hour          :integer ;
    s             :string  ;

begin
  { starting point, all x and y values have these added in before a draw }
  xbias     :=  15;
  ybias     := 113;
  xyscl     :=   2;
  xysiz     := 100;
  halfxysiz :=  50;
  { NOTE that OUR drawing box of 0,0 to 100,100 [i.e. xysiz] scaled by xyscl
    and moved by a bias of xbias, ybias }

  { build radians and degrees converters }
  degtorad := (2 * 3.14162) / 360 ;
  radtodeg := 360 / (2 * 3.14162) ;

  { remove wording to redraw screen }
  { see FormPaint }
  { http://delphi.about.com/library/bluc/text/uc052102d.htm }
  { clear the graph area see: http://delphi.about.com/library/bluc/text/uc052102c.htm}
  Canvas.Rectangle( Bounds(xbias-10, ybias-15, 25+xyscl*xysiz, 35+xyscl*xysiz));

  { say what is depicted }
  Canvas.TextOut  ( xbias+xyscl*0,      ybias-xyscl*7  ,'v dial');

  { move to a starting point if 0,0 (top left) scales and biased of course }
  Canvas.MoveTo   ( xbias+xyscl*0,        ybias+xyscl*0     );
  {                            **                  **
                         user's x            user's y
  }

  { draw a box }
  Canvas.Pen.Color :=  100;   { dark brown }
  Canvas.Pen.Width :=    1;
  Canvas.LineTo   ( xbias+xyscl*xysiz,    ybias+xyscl*0     );
  Canvas.LineTo   ( xbias+xyscl*xysiz,    ybias+xyscl*xysiz );
  Canvas.LineTo   ( xbias+xyscl*0,        ybias+xyscl*xysiz );
  Canvas.LineTo   ( xbias+xyscl*0,        ybias+xyscl*0     );

  { turn pen off and move to top center }
  Canvas.MoveTo   ( xbias+xyscl*halfxysiz,ybias+xyscl*0     );

  { get the numeric values of the longitude and legal meridian }
  { single(Edit2.Text)  or  StrToFloat(Edit2.Text) will do a conversion   }
  difflong    := StrToFloat(Edit2.Text) - StrToFloat(Edit3.Text) ;

  { get the difference as text also }
  difflongstring      := FloatToStr (difflong) ;

  { get latitude }
  lat :=  StrToFloat(Edit1.Text);

  { StringGrid1 is a TStringGrid array with 3 columns and 8 rows }
  degtorad := (2 * 3.14162) / 360 ;
  radtodeg := 360 / (2 * 3.14162) ;

  { get sin and cos(lat) and cos and sin(dec) }
  coslat  := cos( degtorad * lat ) ;

  { if difflong = 0 then we get divide by 0 later to change to trivial number
    that gives a good noon hor lien angle }
  if difflong = 0 then  difflong := 0.001 ;

  {           1 <---- would be noon }
  for irow := 2 to 6 do
  begin
          for icol := 1 to 2 do
          begin
                { get the hour angle of the sun }
                ii := irow - 1 ;
                jj := difflong + (15 * ii) ;
                { however col 2 (actually col 3) is afternoon }
                if icol = 2 then jj := difflong - (15 * ii) ;

                { get the resulting hour line angle }
                { if you dont include "math" in the "uses" at the top, then
                  there is no tan support so you can use sin/cos }

                hla := radtodeg * arctan( coslat * tan(degtorad*jj) );

                { make numbers be positive }
                if hla < 0 then hla := -hla;

                { As signs are removed, noon is west of N:S if dial is west
                  of meridian, east if east. }

                { *** draw line here
                      *** is icol = 1 then am so x values are left of center
                      *** is icol = 2 then pm so x values are right of center
                }
                { move pen to top and center }
                Canvas.Pen.Width :=    1;
                Canvas.Pen.Color :=  255;
                Canvas.Pen.Color :=  250;
                Canvas.MoveTo   ( xbias+xyscl*halfxysiz,ybias+xyscl*0     );
                { angles of less than atan(0.5) have y=100, and you derive x,
                  angles of more than atan(0.5) have x=-50, and you derive y,
                         and atan(0.5) is 26.56505
                  if am, or if noon and dial is west of legal meridian then
                         lines are left of center,
                  if pm, or if noon and dial is east of legal meridian then
                         lines are right of center
                  AM happens if icol = 1, and
                  PM happens if icol = 2
                }
                if hla < 26.56505 then
                begin
                    y  := 100;                               { x,y are floating point }
                    x  := int (y * (tan(degtorad*hla))) ;    { integer part, but still float }
                    { -----------------------------------------------------------------------}
                    {    x,y           :single  ;     ie floating point ------
                         xl,yl         :longint ;     ie integer        ------
                         the objectove it to convert a floating point to an integer }
                    { -----------------------------------------------------------------------}

                    s   := FloatToStrF (y,ffFixed,3,0);
                    yl  := StrToInt (s);

                    s   := FloatToStrF (x,ffFixed,3,0);
                    xl  := StrToInt (s);

                    { draw the line }
                    if icol = 1 then
                       begin
                          xl := halfxysiz - xl;
                       end ;
                    if icol = 2 then
                       begin
                          xl := halfxysiz + xl;
                       end ;
                    Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*yl );
                    { -----------------------------------------------------------------------}
                end;
                if hla > 26.56504 then
                begin
                    x  := 50;
                    y  := x/tan(degtorad*hla);
                    { ---------------------------------------------------------------------------}

                    s  := FloatToStrF (y,ffFixed,3,0);
                    yl  := StrToInt (s);

                    s  := FloatToStrF (x,ffFixed,3,0);
                    xl  := StrToInt (s);

                    { draw the line }
                    if icol = 1 then
                       begin
                          xl := halfxysiz - xl;
                       end ;
                    if icol = 2 then
                       begin
                          xl := halfxysiz + xl;
                       end ;
                    Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*yl );
                    { -----------------------------------------------------------------------}
                end;

                { display the hour }
                if icol = 1 then
                   hour := 13 - irow;
                if icol = 2 then
                   hour := 11 + irow;
                Canvas.TextOut  ( xbias+xyscl*xl,5+ybias+xyscl*yl, IntToStr(hour) );

                { having drawn the line, reset to top and center }
                Canvas.MoveTo   ( xbias+xyscl*halfxysiz,  ybias+xyscl*0     );
          end;
  end ;

  { *** NOON *** }
  { get the hour angle of the sun for noon }
  jj := difflong ;

  { get the resulting hour line angle }
  hla := radtodeg * arctan( coslat*tan(degtorad*jj) );

  { make numbers be positive }
  if hla < 0 then hla := -hla;

  { As signs are removed, noon is west of N:S if dial is west
    of meridian, east if east. }

  { move pen to top and center }
  Canvas.Pen.Width :=    1;
  Canvas.Pen.Color :=  255;
  Canvas.Pen.Color :=  250;
  Canvas.MoveTo   ( xbias+xyscl*halfxysiz,ybias+xyscl*0     );

  y  := 100;                               { x,y are floating point }
  x  := int (y * (tan(degtorad*hla))) ;    { integer part, but still float }

  s  := FloatToStrF (y,ffFixed,3,0);
  yl  := StrToInt (s);

  s  := FloatToStrF (x,ffFixed,3,0);
  xl  := StrToInt (s);

  { draw the line }
  if difflong >=0 then
     begin
        xl := halfxysiz - xl;
     end ;
  if difflong <0 then
     begin
        xl := halfxysiz + xl;
     end ;
  Canvas.LineTo   ( xbias+xyscl*xl,  ybias+xyscl*yl );
  Canvas.TextOut  ( xbias+xyscl*xl,  5+ybias+xyscl*yl, '12');

  { having drawn the line, reset to top and center }
  Canvas.MoveTo   ( xbias+xyscl*halfxysiz,  ybias+xyscl*0     );

end;


{ ********************************************************************** }
{ ***     S T A R T    O F    T R I V I A L    F U N C T I O N S     *** }
{ ********************************************************************** }

procedure TForm1.Edit1Change(Sender: TObject);
begin

end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  { http://delphi.about.com/library/bluc/text/uc052102d.htm }
  Canvas.TextOut(15, 140, 'Window over written so');
  Canvas.TextOut(15, 160, 'click the DRAW button.');
end;

procedure TForm1.Label4Click(Sender: TObject);
begin

end;

procedure TForm1.StaticText2Click(Sender: TObject);
begin

end;

procedure TForm1.StaticText6Click(Sender: TObject);
begin

end;

procedure TForm1.StaticText7Click(Sender: TObject);
begin

end;

initialization
  {$I hdialv1.lrs}

end.

{ ***********
  *** END ***
  ***********
}

